<template lang="pug">
  .container
    article.message.is-danger.has-image-centered(v-if="errorMessage != null")
      .message-header
        p {{errorMessage}}
        button.delete(aria-label="delete",@click="onCloseErrorMessage")
    .tile.is-ancestor
      .tile.is-4
      .tile.is-4.tile.is-child
        form(@submit.prevent="onSignin")
          .field
            label.label Email
            input.input(name="email", id="email", v-model="email", type="email", required)
          .field
            label.label Password        
            input.input(name="password", id="password", v-model="password", type="password", required)
          .field.is-grouped
            .control
              button.button.is-primary(type="submit", :disabled="loading", :class="{'is-loading': loading}") Sign Ip
            .control
              router-link.button.is-ligh(:to="{ path: '/signup' }", :class="{'is-loading': loading}") Sign Un
            .control
              a.button.is-ligh(:disabled="loading", :class="{'is-loading': loading}",@click.prevent="onResetPassword") Reset Password By Email
          br
          .field.is-grouped
            .control        
              a.button.is-dark(:disabled="loading", :class="{'is-loading': loading}",@click.prevent="onSigninGoogle")
                span.icon.is-small
                  font-awesome-icon(:icon="['fab', 'google']")
                span Login with Google          
            .control
              a.button.is-dark(:disabled="loading",:class="{'is-loading': loading}",@click.prevent="onSigninFacebook") 
                span.icon.is-small
                  font-awesome-icon(:icon="['fab', 'facebook']")
                span Login with Facebook          
            .control
              a.button.is-dark(:disabled="loading",:class="{'is-loading': loading}",@click.prevent="onSigninTwitter")
                span.icon.is-small
                  font-awesome-icon(:icon="['fab', 'twitter']")
                span Login with Twitter 
      .tile.is-4
</template>

<style scoped>
  .is-ancestor {
    margin: 50px 0;
  } 
</style>

<script>
  export default {
    data () {
      return {
        email: '',
        password: ''
      }
    },
    computed: {
      user () {
        return this.$store.getters.user
      },
      errorMessage () {
        return _.get(this.$store, 'getters.error.message', null)
      },
      loading () {
        return this.$store.getters.loading
      }
    },
    watch: {
      user (value) {
        if (value !== null && value !== undefined) {
          this.$router.push('/')
        }
      }
    },
    methods: {
      onCloseErrorMessage () {
        return this.$store.dispatch('setError', {message: null})
      },
      onSignin () {
        this.$store.dispatch('signUserIn', {email: this.email, password: this.password})
      },
      onSigninGoogle () {
        this.$store.dispatch('signUserInGoogle')
      },
      onSigninFacebook () {
        this.$store.dispatch('signUserInFacebook')
      },
      onSigninTwitter () {
        this.$store.dispatch('signUserInTwitter')
      },
      onResetPassword () {
        if (this.email === '') {
          return this.$store.dispatch('setError', {message: 'Email can not be blank'})
        }
        this.$store.dispatch('resetPasswordWithEmail', {email: this.email})
      },
      onDismissed () {
        this.$store.dispatch('clearError')
      }
    }
  }
</script>
